void fSerdesSbCycleDelay(unsigned int n) {
  int i;
  for(i = 0; i<n; i++);
}

unsigned int fSerdesSbRead32(unsigned int addr)
  {
  return(*(volatile unsigned int *)(addr));
  }

unsigned int fSerdesSbReadTbusVal(unsigned int iSerdesCfgBase)
{
  	int iPhyA = (iSerdesCfgBase != 0x0231e000);
  	unsigned int iTmp;

  	if(iPhyA)
   	 {
   		iTmp  = (*(volatile unsigned int *)( iSerdesCfgBase + 0x0ec) >> 24) & 0x0ff;
    	iTmp |= (*(volatile unsigned int *)( iSerdesCfgBase +  0x0fc) >> 16) & 0x00f00;
   	 }
   	else
    {
    	iTmp  = (*(volatile unsigned int *)( iSerdesCfgBase + 0x0f8) >> 16) & 0x0fff;
    }
  	return(iTmp);
}

void write_32_mask(unsigned int in_base,unsigned int iKeepMask,unsigned int iSetValue)
{
	unsigned int iTmp;

  	iTmp = *(volatile unsigned int *)(in_base);
	iTmp &= iKeepMask;
 	iTmp |= ((~iKeepMask)&iSetValue);
  	*(volatile unsigned int *)( in_base) = iTmp; 
}

void fSerdesSbWriteTbusAddr(unsigned int iSerdesCfgBase, int iSelect, int iOffset)
{
    int iPhyA     = (iSerdesCfgBase != 0x0231e000);
  int iTwoLaner;

    iTwoLaner = (*(volatile unsigned int *)( iSerdesCfgBase + 0x1fc0)>>16)&0x0ffff;
  if ((iTwoLaner==0x4eb9)||(iTwoLaner==0x4ebd)) iTwoLaner=0; else iTwoLaner=1;
  if ((iSelect)&&(iTwoLaner)) iSelect++;

   if (iPhyA)
    {
    write_32_mask(iSerdesCfgBase+0x0008, 0x00FFFFFF, (((iSelect) << 5) + iOffset) << 24);
    }
     else
  {
    write_32_mask(iSerdesCfgBase+0x00fc, 0xf800ffff, (((iSelect) << 8) + iOffset) << 16);
  }
}

unsigned int fSerdesSbReadSelectedTbus(unsigned int iSerdesCfgBase,int iSelect,int iOffset)
{
  fSerdesSbWriteTbusAddr(iSerdesCfgBase,iSelect,iOffset);   //Set tbus address
  return(fSerdesSbReadTbusVal(iSerdesCfgBase));             //Get TBUS Value
}

void fUserRegFillField32(uint32_t iAddress,uint32_t iOffset,uint32_t iWidth,uint32_t iValue)
{
  uint32_t iMask,iTmp;
  uint32_t i;

  for(i=0,iMask=0;i<iWidth;i++)
  iMask = (iMask<<1)|1;
  
  iValue&=iMask;
  iValue <<= iOffset;
  iMask  <<= iOffset;
  iTmp = *(volatile uint32_t *)(iAddress);
  iTmp &= ~iMask;
  iTmp |= iValue;
  *(volatile uint32_t *)(iAddress) = iTmp;
}

int check_rxvalid(unsigned int in_base,int lane_no)
  {

    int timeoutloops=100000000;
    unsigned int stat;
    unsigned int iPhyB = (in_base == 0x0231e000);

    //timeoutloops = TIMEOUTL;


    // check for lnX_stat[3:2] to go high on both lanes, this indicates that adaptation has completed
    // timeout for lanes that are not connected
    stat= (fSerdesSbReadSelectedTbus(in_base,lane_no+1,0x2) & 0x0060) >> 5;
    while ((stat != 3) && (timeoutloops != 0))
    {
                    stat= (fSerdesSbReadSelectedTbus(in_base,lane_no+1,0x2) & 0x0060) >> 5;
                    timeoutloops--;
    }


//                              fSerdesSbCycleDelay(300000); // adding the rest of the delay ~ 300us
    return timeoutloops;
  }

int boost_workaround(uint32_t in_base, int iLanes, int iPhyB) {
  unsigned int boost_read=0, att_read=0,att_start;
  int i;

  for(i=0;i<iLanes;i++){

        // first read initial att start value
        att_start = (*(volatile unsigned int *)(in_base + (i * 0x200) + 0x200 + 0x8c)>>8)&0xF;

        // check att value, fix this as start value turn off att adaptation and do boost readaptation
        att_read = (fSerdesSbReadSelectedTbus(in_base,i+1,iPhyB?0x10:0x11)>>4)&0xF;
        fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x8c,8,4,att_read); //att start
        fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x9c,0,1,0);
        fUserRegFillField32(in_base + 0x0a00 + 0x8c,24,1,0);

        // force cal
        fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x98,14,1,1);
        fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x98,14,1,0);

        //Keegan did not hav it in the test.
        //if (!check_rxvalid(in_base,i)) return 0;

        // check boost value
        boost_read = (fSerdesSbReadSelectedTbus(in_base,i+1,iPhyB?0x10:0x11)>>8)&0xF;
        // if boost=0, increment by 1
        if (boost_read == 0) {

            // set rxeq_ovr_en to 1
            fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x2c,2,1,1);

            // set rxeq_ovr_load_en for boost only
            fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x2c,12,7,0x2);

            // set rxeq_ovr_load for a value of 1
            fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x2c,3,7,0x1);

            // latch in new boost value
            fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x2c,10,1,0x1);
            fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x2c,10,1,0x0);

            // reset previous registers
            fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x2c,2,1,0x0);
            fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x2c,12,7,0x0);
            fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x2c,3,7,0x0);

        }

        //write back initial att start value
        fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x8c,8,4,att_start); //att start
        // turn back on att adaptation
        fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x9c,0,1,1);
        fUserRegFillField32(in_base + 0x0a00 + 0x8c,24,1,1);
  }
  return 1;
}
/***************************/
void boost_workaround_LANE(unsigned int in_base, int i)  //Must be called when RxValid is true
{
  unsigned int boost_read=0, att_read=0, att_start;
  int iPhyB = (in_base == 0x0231e000);

  // first read initial att start value
  att_start = (*(volatile unsigned int *)(in_base + (i * 0x200) + 0x200 + 0x8c)>>8)&0xF;

  // check att value, fix this as start value turn off att adaptation and do boost readaptation

  att_read = (fSerdesSbReadSelectedTbus(in_base,i+1,iPhyB?0x10:0x11)>>4)&0xF;
  fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x8c,8,4,att_read); //att start
  fUserRegFillField32(in_base + (i * 0x200) + 0x200 + (iPhyB?0x9c:0x84),0,1,0);  //Clear att init cal
  fUserRegFillField32(in_base + 0x0a00 + 0x8c,24,1,0);  //Clear att recal

  // force cal
  fUserRegFillField32(in_base + (i * 0x200) + 0x200 + (iPhyB?0x98:0xac),(iPhyB?14:11),1,1); //Set att continious recal
  fUserRegFillField32(in_base + (i * 0x200) + 0x200 + (iPhyB?0x98:0xac),(iPhyB?14:11),1,0); //Clear att continious cal
  //fCycleDelay(300000); // adding the rest of the delay ~ 300us just in case
  usleep(300);
//#if WAIT_FOR_VALID
  check_rxvalid(in_base, i);
//#endif
  // check boost value
  boost_read = (fSerdesSbReadSelectedTbus(in_base,i+1,iPhyB?0x10:0x11)>>8)&0xF;
  // if boost=0, increment by 1
  if (boost_read == 0)
  {
    // set rxeq_ovr_en to 1
    fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x2c,2,1,1);

    // set rxeq_ovr_load_en for boost only
    fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x2c,12,7,0x2);

    // set rxeq_ovr_load for a value of 1
    fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x2c,3,7,0x1);

    // latch in new boost value
    fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x2c,10,1,0x1);
    fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x2c,10,1,0x0);

    // reset previous registers
    fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x2c,2,1,0x0);
    fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x2c,12,7,0x0);
    fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x2c,3,7,0x0);
  }

  //write back initial att start value
  fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x8c,8,4,att_start); //att start
  // turn back on att adaptation
  fUserRegFillField32(in_base + (i * 0x200) + 0x200 + (iPhyB?0x9c:0x84),0,1,1);  //Set att init cal
  fUserRegFillField32(in_base + 0x0a00 + 0x8c,24,1,1);
}
/***************************/
uint32_t termination_workaround1(uint32_t in_base, int iPhyA) {
  return fSerdesSbReadSelectedTbus(in_base,0+1,(iPhyA)?(0x1b):(0x1a)) & 0x00ff;
}

uint32_t get_dlpf (uint32_t in_base, int lane_no) {
  return (fSerdesSbReadSelectedTbus(in_base,lane_no+1,0x05) >> 2) & 0x3ff;
}

void termination_workaround2(uint32_t in_base, int iLanes, uint32_t iTxTermNP) {
  int i;
  for(i=0;i<iLanes;i++)
  {
  fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x7c,24,8,iTxTermNP); //Set Tx Termination
  fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x7c,20,1,1);    //Set termination override
  }
}

uint32_t get_att_boost_values(uint32_t in_base, int lane_no, int iPhyB) {
  return fSerdesSbReadSelectedTbus( in_base, lane_no+1, iPhyB?0x10:0x11);
 }

//rate 0 = full
//rate 1 = half
void rx_block_workaround(uint32_t in_base, int rate){
  if (rate == 0)
    fUserRegFillField32(in_base + 0x0a00 + 0x0c8, 0,6,0x03);
  else if (rate == 1)
    fUserRegFillField32(in_base + 0x0a00 + 0x0c4, 24,6,0x03);
}

// Force serdes signal detect LO
void reset_cdr_att_boost(uint32_t in_base, int iLanes) {
  int i;
  for(i=0;i<iLanes;i++) fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x04,1,2,2);  
}

// Allow serdes to re-acquire Signal Detect
void deassert_reset_cdr_att_boost(uint32_t in_base, int iLanes) {
  int i;
  for(i=0;i<iLanes;i++) fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x04,1,2,0);  
}

// Disable transmitter, forcing to idle
void disable_transmitter(uint32_t in_base, int iLane) {
  fUserRegFillField32(in_base + (iLane * 0x4) + 0x1fc0 + 0x020,24,2,3); //Disable transmitter
}

// Enable transmitter, forcing to normal
void enable_transmitter(uint32_t in_base, int iLane) {
  fUserRegFillField32(in_base + (iLane * 0x4) + 0x1fc0 + 0x020,24,2,0); //Enable Transmitter
}

void fSerdesSbAssertReset(unsigned int in_base)
  {
  int i;

  //Assert reset while preserving the lnX_ctrl_i bits!

  for(i=0;i<4;i++)
    {
    unsigned int uiTmp0,uiTmp1,uiTmpO;

    uiTmp0=fSerdesSbReadSelectedTbus(in_base,i+1,0); //Read lnX_ctrl_i/lnX_pd_i
    uiTmp1=fSerdesSbReadSelectedTbus(in_base,i+1,1); //Read lnX_rate_i
    uiTmpO =  0;                          //Set Reset State
    uiTmpO |= ((uiTmp1>>9)&0x003)<<1;     //Add user Rate
    uiTmpO |= ((uiTmp0   )&0x003)<<3;     //Add user PD
    uiTmpO |= ((uiTmp0>>2)&0x1FF)<<5;     //Add user ctrl_i
    uiTmpO |= (1<<14);                    //Set Overide
    uiTmpO &= ~0x60;                      //Try Clear the Tx Valid bits!

    //Only modify the reset bit and the overlay bit

    fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x28,15,15,uiTmpO);
    }
  }

void fSerdesSbDeassertReset(unsigned int in_base,int iLanes)
  {
  //Clear the Reset bit
  fUserRegFillField32(in_base + (3 * 0x200) + 0x200 + 0x28,15,1,1);
  fUserRegFillField32(in_base + (2 * 0x200) + 0x200 + 0x28,15,1,1);
  fUserRegFillField32(in_base + (1 * 0x200) + 0x200 + 0x28,15,1,1);
  fUserRegFillField32(in_base + (0 * 0x200) + 0x200 + 0x28,15,1,1);

  //CHECK LANE OK for all lanes requested
  if (iLanes)
    {
    unsigned int iTmp;
    int i;

    for(i=0,iTmp=0;i<iLanes;i++) iTmp=(iTmp<<1)|1;
    iTmp=((fSerdesSbRead32(in_base + 0x1fc0 + 0x00)>>16)&1)?(iTmp<<28):(iTmp<<29);  //B8 or B4 OK Mask
    while((fSerdesSbRead32(in_base + 0xa00 + 0x1f8) & iTmp) != iTmp);
    }
  //Clear Overlay bit
  fUserRegFillField32(in_base + (3 * 0x200) + 0x200 + 0x28,29,1,0);
  fUserRegFillField32(in_base + (2 * 0x200) + 0x200 + 0x28,29,1,0);
  fUserRegFillField32(in_base + (1 * 0x200) + 0x200 + 0x28,29,1,0);
  fUserRegFillField32(in_base + (0 * 0x200) + 0x200 + 0x28,29,1,0);
  }

void port_ok_workaround(uint32_t in_base)
{
  //
  reset_cdr_att_boost(in_base, 4);

  //
  deassert_reset_cdr_att_boost(in_base, 4);

  //
  boost_workaround(in_base, 4, 0);
}

void fSbSerdesPhyaPatchLane(int iBase,int iLane)
  {
  //Appliy Patches
  //fSerdesAddField(iBase,3,"Patch_b");
  fUserRegFillField32(iBase + (iLane * 0x200) + 0x200 + 0x18,26,2, 2); //pma_ln_vregh
  fUserRegFillField32(iBase + (iLane * 0x200) + 0x200 + 0x18,24,2, 2); //pma_ln_vreg
  fUserRegFillField32(iBase + (iLane * 0x200) + 0x200 + 0x8c, 8,4,10); //att start
  fUserRegFillField32(iBase + (iLane * 0x200) + 0x200 + 0x8c,12,4,10); //boost start
  fUserRegFillField32(iBase + (iLane * 0x200) + 0x200 + 0x14,13,3, 1); //pma_int_step
  fUserRegFillField32(iBase + (iLane * 0x200) + 0x200 + 0x4c,16,4,15); //turn off att_boost
  fUserRegFillField32(iBase + (iLane * 0x200) + 0x200 + 0x4c,20,4,10); //set dfe_bias to 10
  fUserRegFillField32(iBase + (iLane * 0x200) + 0x200 + 0x78,24,7,127); //set offset avg numsamples to max value
  // this sequence powers up DFE taps and sets tap1 to a value of 58 (range for tap1 = 0-128, 64 is no effect)
  //fUserRegFillField32(in_base + 0x0a00 + 0xbc,24,5,0); //power up taps
  //fUserRegFillField32(in_base + (i * 0x200) + 0x200 + 0x8c,16,7,58); //set tap 1 start to -6
  }

void display_boost_att_termination(uint32_t index, uint32_t baseAddr, uint32_t numLanes, uint32_t check_point)
{
uint32_t i, iAtt, iTxTermNP, iBoost;
    iTxTermNP = termination_workaround1(baseAddr, 1);
    mpm_printf(1, "%03d #port%d hyplnkSerdes: iTxTermNP is 0x%x\n", check_point, index, iTxTermNP);
    for (i = 0; i < numLanes; i++) {
      iAtt = iBoost = get_att_boost_values(baseAddr, i, 0);
      iAtt = (iAtt >> 4) & 0x0f;
      iBoost = (iBoost >> 8) & 0x0f;
      mpm_printf(1, "%03d #port%d hyplnkSerdes: lane %d; Att = %d, Boost = %d\n", check_point, index, i, iAtt, iBoost);
    }
}

/************************************************************************************************************************/
#if 0
// Set global variables for comparator and tap averaged offset values
unsigned int cmp_offset_global[4][5]  = {0,0};
unsigned int tap1_offset_global[4][5] = {0,0};
unsigned int tap2_offset_global[4][5] = {0,0};
unsigned int tap3_offset_global[4][5] = {0,0};
unsigned int tap4_offset_global[4][5] = {0,0};
unsigned int tap5_offset_global[4][5] = {0,0};


// Function to work out average comp/tap offset after num_resets number of resets
void fSerdesSbFindAverageOffsets(unsigned int in_base, int iLanes, int num_resets)
  {
  unsigned int i,j,lane_no,comp_no,iMinCmp[4][5],iMaxCmp[4][5],iMinTap1[4][5],iMaxTap1[4][5],iMinTap2[4][5],iMaxTap2[4][5],iMinTap3[4][5],iMaxTap3[4][5],iMinTap4[4][5],iMaxTap4[4][5],iMinTap5[4][5],iMaxTap5[4][5];
  unsigned int iZeroCmp[4][5],iZeroTap1[4][5],iZeroTap2[4][5],iZeroTap3[4][5],iZeroTap4[4][5],iZeroTap5[4][5];
  unsigned int iZeroCmpCnt[4][5],iZeroTap1Cnt[4][5],iZeroTap2Cnt[4][5],iZeroTap3Cnt[4][5],iZeroTap4Cnt[4][5],iZeroTap5Cnt[4][5];
  unsigned int cmp_offset_tmp,tap1_offset_tmp,tap2_offset_tmp,tap3_offset_tmp,tap4_offset_tmp,tap5_offset_tmp;

  // Some caveots, the way this is written, once called by for a SERDES global variables are only for that SERDES.
  // It needs to return the info in a passed structure so that it can be run for all SERDES then used as needed.
  // It also looks like if you do not enable the DFE, the DFE values can be zero sometimes!

  for(i=0;i<iLanes;i++) //Reset the stuff
    for(j=0;j<5;j++)
      {
      cmp_offset_global[i][j] =0;
      tap1_offset_global[i][j]=0;
      tap2_offset_global[i][j]=0;
      tap3_offset_global[i][j]=0;
      tap4_offset_global[i][j]=0;
      tap5_offset_global[i][j]=0;
      iMinCmp[i][j] =0x0ffffff; iMaxCmp[i][j] =0;
      iMinTap1[i][j]=0x0ffffff; iMaxTap1[i][j]=0;
      iMinTap2[i][j]=0x0ffffff; iMaxTap2[i][j]=0;
      iMinTap3[i][j]=0x0ffffff; iMaxTap3[i][j]=0;
      iMinTap4[i][j]=0x0ffffff; iMaxTap4[i][j]=0;
      iMinTap5[i][j]=0x0ffffff; iMaxTap5[i][j]=0;
      iZeroCmpCnt[i][j] =0;
      iZeroTap1Cnt[i][j]=0;
      iZeroTap2Cnt[i][j]=0;
      iZeroTap3Cnt[i][j]=0;
      iZeroTap4Cnt[i][j]=0;
      iZeroTap5Cnt[i][j]=0;
      }
  for(i=0;i<num_resets;i++)
    {
    unsigned int iTmp;

    cfg_serdes_assert_reset(in_base);
    cfg_serdes_deassert_reset(in_base,1,iLanes);
    iTmp=serdes_read32(in_base + 0x1fc0 + 0x34);
    iTmp >>= 8;
    iTmp &= 0x0f;
    if ((iLanes==2)&&(iTmp!=0x03)) printf("Lane OK Not Set: %02x - %d\n",i,iTmp);
    if ((iLanes==4)&&(iTmp!=0x0f)) printf("Lane OK Not Set: %02x - %d\n",i,iTmp);
    if(in_base==0x0231E000)
      {		//KR
      for(lane_no=0;lane_no<iLanes;lane_no++)
        {
        for(comp_no=1;comp_no<5;comp_no++)
          {//Set comparator number
          fUserRegFillField32(in_base + 0x0a00 + 0x8c,21,3,comp_no); //Write comparator value

          fUserRegFillField32(in_base + 0x0fc,16,11,0x11+((lane_no+2)<<8));  //Set tbus address
          cmp_offset_tmp=(fSerdesSbReadTbusVal(in_base) & 0x0ff0)>>4;
          fUserRegFillField32(in_base + 0x0fc,16,11,0x11+((lane_no+2)<<8));  //Set tbus address
          tap1_offset_tmp=(fSerdesSbReadTbusVal(in_base) & 0x000f)<<3;
          fUserRegFillField32(in_base + 0x0fc,16,11,0x12+((lane_no+2)<<8));  //Set tbus address
          tap1_offset_tmp = tap1_offset_tmp | ((fSerdesSbReadTbusVal(in_base) & 0x0e00)>>9);
          tap2_offset_tmp = (fSerdesSbReadTbusVal(in_base) & 0x01f8)>>3;
          tap3_offset_tmp=(fSerdesSbReadTbusVal(in_base) & 0x007)<<3;
          fUserRegFillField32(in_base + 0x0fc,16,11,0x13+((lane_no+2)<<8));  //Set tbus address
          tap3_offset_tmp= tap3_offset_tmp | ((fSerdesSbReadTbusVal(in_base) & 0xe00)>>9);
          tap4_offset_tmp=(fSerdesSbReadTbusVal(in_base) & 0x01f8)>>3;
          tap5_offset_tmp=(fSerdesSbReadTbusVal(in_base) & 0x0007)<<3;
          fUserRegFillField32(in_base + 0x0fc,16,11,0x14+((lane_no+2)<<8));  //Set tbus address
          tap5_offset_tmp=tap5_offset_tmp | ((fSerdesSbReadTbusVal(in_base) & 0x0e00)>>9);

          // take a running count of comparator and tap offsets for num_resets number of runs
          cmp_offset_global[lane_no][comp_no] = cmp_offset_global[lane_no][comp_no]+cmp_offset_tmp;
          tap1_offset_global[lane_no][comp_no] = tap1_offset_global[lane_no][comp_no]+tap1_offset_tmp;
          tap2_offset_global[lane_no][comp_no] = tap2_offset_global[lane_no][comp_no]+tap2_offset_tmp;
          tap3_offset_global[lane_no][comp_no] = tap3_offset_global[lane_no][comp_no]+tap3_offset_tmp;
          tap4_offset_global[lane_no][comp_no] = tap4_offset_global[lane_no][comp_no]+tap4_offset_tmp;
          tap5_offset_global[lane_no][comp_no] = tap5_offset_global[lane_no][comp_no]+tap5_offset_tmp;

          if (cmp_offset_tmp>iMaxCmp[lane_no][comp_no]) iMaxCmp[lane_no][comp_no]=cmp_offset_tmp;
          if (cmp_offset_tmp<iMinCmp[lane_no][comp_no]) iMinCmp[lane_no][comp_no]=cmp_offset_tmp;
          if (tap1_offset_tmp>iMaxTap1[lane_no][comp_no]) iMaxTap1[lane_no][comp_no]=tap1_offset_tmp;
          if (tap1_offset_tmp<iMinTap1[lane_no][comp_no]) iMinTap1[lane_no][comp_no]=tap1_offset_tmp;
          if (tap2_offset_tmp>iMaxTap2[lane_no][comp_no]) iMaxTap2[lane_no][comp_no]=tap2_offset_tmp;
          if (tap2_offset_tmp<iMinTap2[lane_no][comp_no]) iMinTap2[lane_no][comp_no]=tap2_offset_tmp;
          if (tap3_offset_tmp>iMaxTap3[lane_no][comp_no]) iMaxTap3[lane_no][comp_no]=tap3_offset_tmp;
          if (tap3_offset_tmp<iMinTap3[lane_no][comp_no]) iMinTap3[lane_no][comp_no]=tap3_offset_tmp;
          if (tap4_offset_tmp>iMaxTap4[lane_no][comp_no]) iMaxTap4[lane_no][comp_no]=tap4_offset_tmp;
          if (tap4_offset_tmp<iMinTap4[lane_no][comp_no]) iMinTap4[lane_no][comp_no]=tap4_offset_tmp;
          if (tap5_offset_tmp>iMaxTap5[lane_no][comp_no]) iMaxTap5[lane_no][comp_no]=tap5_offset_tmp;
          if (tap5_offset_tmp<iMinTap5[lane_no][comp_no]) iMinTap5[lane_no][comp_no]=tap5_offset_tmp;
          if (cmp_offset_tmp==0)  {iZeroCmp[lane_no][comp_no] =i; iZeroCmpCnt[lane_no][comp_no]++; }
          if (tap1_offset_tmp==0) {iZeroTap1[lane_no][comp_no]=i; iZeroTap1Cnt[lane_no][comp_no]++;}
          if (tap2_offset_tmp==0) {iZeroTap2[lane_no][comp_no]=i; iZeroTap2Cnt[lane_no][comp_no]++;}
          if (tap3_offset_tmp==0) {iZeroTap3[lane_no][comp_no]=i; iZeroTap3Cnt[lane_no][comp_no]++;}
          if (tap4_offset_tmp==0) {iZeroTap4[lane_no][comp_no]=i; iZeroTap4Cnt[lane_no][comp_no]++;}
          if (tap5_offset_tmp==0) {iZeroTap5[lane_no][comp_no]=i; iZeroTap5Cnt[lane_no][comp_no]++;}
          }
        }
      }
     else
      {
      for(lane_no=0;lane_no<iLanes;lane_no++)
        {
        for(comp_no=1;comp_no<5;comp_no++)
          {//Set comparator number
          fUserRegFillField32(in_base + 0x0a00 + 0x8c,21,3,comp_no); //Write comparator value
          fUserRegFillField32(in_base + 0x008,24,8,0x12+((lane_no+1)<<5));  //Set tbus address
          cmp_offset_tmp=(fSerdesSbReadTbusVal(in_base) & 0x0ff0)>>4;

          // take a running count of comparator and tap offsets for num_resets number of runs
          cmp_offset_global[lane_no][comp_no] = cmp_offset_global[lane_no][comp_no]+cmp_offset_tmp;
          }
        }
      }
    }

  // Get average value for each comparator and tap offset
  if(in_base==0x0231E000)
    {		//KR
    for(lane_no=0;lane_no<iLanes;lane_no++)
      {
      for(comp_no=1;comp_no<5;comp_no++)
        {//Set comparator number
        char sTmp[80];

        cmp_offset_global[lane_no][comp_no] = cmp_offset_global[lane_no][comp_no]/num_resets;
        tap1_offset_global[lane_no][comp_no] = tap1_offset_global[lane_no][comp_no]/num_resets;
        tap2_offset_global[lane_no][comp_no] = tap2_offset_global[lane_no][comp_no]/num_resets;
        tap3_offset_global[lane_no][comp_no] = tap3_offset_global[lane_no][comp_no]/num_resets;
        tap4_offset_global[lane_no][comp_no] = tap4_offset_global[lane_no][comp_no]/num_resets;
        tap5_offset_global[lane_no][comp_no] = tap5_offset_global[lane_no][comp_no]/num_resets;

        if (iMinCmp[lane_no][comp_no]==0) sprintf(sTmp," - LastIdx: %d, Count: %d",iZeroCmp[lane_no][comp_no],iZeroCmpCnt[lane_no][comp_no]); else sTmp[0]=0;
        printf("cmp_offset_global  Lane: %d, Comp: %d, Avg: %3d, Min: %3d, Max: %3d%s Range: %d\n",lane_no,comp_no,cmp_offset_global[lane_no][comp_no],iMinCmp[lane_no][comp_no],iMaxCmp[lane_no][comp_no],sTmp,(iMaxCmp[lane_no][comp_no]-iMinCmp[lane_no][comp_no])+1);
        if (iMinTap1[lane_no][comp_no]==0) sprintf(sTmp," - LastIdx: %d, Count: %d",iZeroTap1[lane_no][comp_no],iZeroTap1Cnt[lane_no][comp_no]); else sTmp[0]=0;
        printf("tap1_offset_global Lane: %d, Comp: %d, Avg: %3d, Min: %3d, Max: %3d%s Range: %d\n",lane_no,comp_no,tap1_offset_global[lane_no][comp_no],iMinTap1[lane_no][comp_no],iMaxTap1[lane_no][comp_no],sTmp,(iMaxTap1[lane_no][comp_no]-iMinTap1[lane_no][comp_no])+1);
        if (iMinTap2[lane_no][comp_no]==0) sprintf(sTmp," - LastIdx: %d, Count: %d",iZeroTap2[lane_no][comp_no],iZeroTap2Cnt[lane_no][comp_no]); else sTmp[0]=0;
        printf("tap2_offset_global Lane: %d, Comp: %d, Avg: %3d, Min: %3d, Max: %3d%s Range: %d\n",lane_no,comp_no,tap2_offset_global[lane_no][comp_no],iMinTap2[lane_no][comp_no],iMaxTap2[lane_no][comp_no],sTmp,(iMaxTap2[lane_no][comp_no]-iMinTap2[lane_no][comp_no])+1);
        if (iMinTap3[lane_no][comp_no]==0) sprintf(sTmp," - LastIdx: %d, Count: %d",iZeroTap3[lane_no][comp_no],iZeroTap3Cnt[lane_no][comp_no]); else sTmp[0]=0;
        printf("tap3_offset_global Lane: %d, Comp: %d, Avg: %3d, Min: %3d, Max: %3d%s Range: %d\n",lane_no,comp_no,tap3_offset_global[lane_no][comp_no],iMinTap3[lane_no][comp_no],iMaxTap3[lane_no][comp_no],sTmp,(iMaxTap3[lane_no][comp_no]-iMinTap3[lane_no][comp_no])+1);
        if (iMinTap4[lane_no][comp_no]==0) sprintf(sTmp," - LastIdx: %d, Count: %d",iZeroTap4[lane_no][comp_no],iZeroTap4Cnt[lane_no][comp_no]); else sTmp[0]=0;
        printf("tap4_offset_global Lane: %d, Comp: %d, Avg: %3d, Min: %3d, Max: %3d%s Range: %d\n",lane_no,comp_no,tap4_offset_global[lane_no][comp_no],iMinTap4[lane_no][comp_no],iMaxTap4[lane_no][comp_no],sTmp,(iMaxTap4[lane_no][comp_no]-iMinTap4[lane_no][comp_no])+1);
        if (iMinTap5[lane_no][comp_no]==0) sprintf(sTmp," - LastIdx: %d, Count: %d",iZeroTap5[lane_no][comp_no],iZeroTap5Cnt[lane_no][comp_no]); else sTmp[0]=0;
        printf("tap5_offset_global Lane: %d, Comp: %d, Avg: %3d, Min: %3d, Max: %3d%s Range: %d\n",lane_no,comp_no,tap5_offset_global[lane_no][comp_no],iMinTap5[lane_no][comp_no],iMaxTap5[lane_no][comp_no],sTmp,(iMaxTap5[lane_no][comp_no]-iMinTap5[lane_no][comp_no])+1);
        }
      }
    }
   else
    {
    for(lane_no=0;lane_no<iLanes;lane_no++)
      {
      for(comp_no=1;comp_no<5;comp_no++)
        {//Set comparator number
        cmp_offset_global[lane_no][comp_no] = cmp_offset_global[lane_no][comp_no]/num_resets;
        }
      }
    }
  }
#if 1
// Force comparator and tap offsets to override value
void OVR_CMP_TAP_OFFSETS(unsigned int in_base, unsigned int lane_no, unsigned int comp_no, unsigned int comp_val, unsigned int tap1_val, unsigned int tap2_val, unsigned int tap3_val, unsigned int tap4_val, unsigned int tap5_val)
  {
  //set dfe_shadow_lane_sel
  fUserRegFillField32(in_base + 0x0a00 + 0xF0,26,2,lane_no+1);
  //set cmp_offset_ovr_en to 1
  fUserRegFillField32(in_base + 0x0a00 + 0x98,24,1,1);
  // Set rxeq_ovr_en to 0x1
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x2C,2,1,1);
  // set rxeq_dfe_cmp_sel_ovr to comp_no
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x30,5,3,comp_no);
  // set dfe_tap_ovr_en to 1
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x5C,31,1,1);

  // set cmp_offset_ovr to i
  fUserRegFillField32(in_base + 0x0a00 + 0x9C,0,8,comp_val);
  // set tap overrides
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x58,24,7,tap1_val);
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x5C,0,6,tap2_val);
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x5C,8,6,tap3_val);
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x5C,16,6,tap4_val);
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x5C,24,6,tap5_val);

  // set rxeq_ovr_latch_o = 0x1
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x2C,10,1,1);
  // set rxeq_ovr_latch_o = 0x0
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x2C,10,1,0);

  //set cmp_offset_ovr_en to 0
  fUserRegFillField32(in_base + 0x0a00 + 0x98,24,1,0);
  // Set rxeq_ovr_en to 0x0
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x2C,2,1,0);
  // set dfe_tap_ovr_en to 0
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x5C,31,1,0);
  }

// Force comparator and tap offsets to override value for CDFE adaptation
void OVR_CMP_TAP_OFFSETS_CDFE(unsigned int in_base, unsigned int lane_no,unsigned int comp_no, unsigned int comp_val, unsigned int tap1_val, unsigned int tap2_val, unsigned int tap3_val, unsigned int tap4_val, unsigned int tap5_val)
  {
  // Enable overrides
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x58,16,1,1);
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x48,16,1,1);

  // Enable comp offset cal
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x58,18,1,1);
  // set gcfsm_cmp_sel to comp_no
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x4C,2,4,comp_no);

  // Set comparator offset
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x48,17,8,comp_val);

  // latch in value
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x48,29,1,1);
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x48,29,1,0);

  // Disable comp offset cal
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x58,18,1,0);
  // Enable tap offset cal
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x58,17,1,1);

  // Enable tap 1
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x58,19,5,1);
  // set tap offset
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x48,17,7,tap1_val);
  // latch in value
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x48,29,1,1);
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x48,29,1,0);

  // Enable tap 2
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x58,19,5,2);
  // set tap offset
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x48,17,6,tap2_val);
  // latch in value
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x48,29,1,1);
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x48,29,1,0);

  // Enable tap 3
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x58,19,5,4);
  // set tap offset
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x48,17,6,tap3_val);
  // latch in value
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x48,29,1,1);
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x48,29,1,0);

  // Enable tap 4
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x58,19,5,8);
  // set tap offset
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x48,17,6,tap4_val);
  // latch in value
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x48,29,1,1);
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x48,29,1,0);

  // Enable tap 5
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x58,19,5,16);
  // set tap offset
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x48,17,6,tap5_val);
  // latch in value
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x48,29,1,1);
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x48,29,1,0);

  // Disable overrides
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x58,16,1,0);
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x48,16,1,0);
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x58,18,1,0);
  fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x58,17,1,0);
}
//------------------------------------------------------------------------------------------------
// Writes out averaged comparator and tap offsets to PCS by overriding the value obtained in reset
//------------------------------------------------------------------------------------------------
void fSerdesSbWriteAverageOffsets(unsigned int in_base, int iLanes)
  {
  unsigned int i,lane_no,comp_no;
  char sTmp[80];

  // rewrite average comparator and tap offsets to comps/taps
  if(in_base==0x0231E000)
    {		//KR
    for(lane_no=0;lane_no<iLanes;lane_no++)
      {
#if 0 // Done outside now
      fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x04,1,2,2);                //Force SERDES Signal Detect LO (Reset CDR, Att and Boost)
#endif
      i = 1;
      for(comp_no=1;comp_no<5;comp_no++)
        {//Set comparator number
#if 0
        printf("Average comp offset for lane %d, comp %d = %d\n", lane_no,comp_no,cmp_offset_global[lane_no][comp_no]);
        printf("Average tap1 offset for lane %d, comp %d = %d\n", lane_no,comp_no,tap1_offset_global[lane_no][comp_no]);
        printf("Average tap2 offset for lane %d, comp %d = %d\n", lane_no,comp_no,tap2_offset_global[lane_no][comp_no]);
        printf("Average tap3 offset for lane %d, comp %d = %d\n", lane_no,comp_no,tap3_offset_global[lane_no][comp_no]);
        printf("Average tap4 offset for lane %d, comp %d = %d\n", lane_no,comp_no,tap4_offset_global[lane_no][comp_no]);
        printf("Average tap5 offset for lane %d, comp %d = %d\n", lane_no,comp_no,tap5_offset_global[lane_no][comp_no]);
#endif
#if 1
        OVR_CMP_TAP_OFFSETS(in_base,lane_no,comp_no,cmp_offset_global[lane_no][comp_no],tap1_offset_global[lane_no][comp_no],tap2_offset_global[lane_no][comp_no],tap3_offset_global[lane_no][comp_no],tap4_offset_global[lane_no][comp_no],tap5_offset_global[lane_no][comp_no]);
        OVR_CMP_TAP_OFFSETS_CDFE(in_base,lane_no,i,cmp_offset_global[lane_no][comp_no],tap1_offset_global[lane_no][comp_no],tap2_offset_global[lane_no][comp_no],tap3_offset_global[lane_no][comp_no],tap4_offset_global[lane_no][comp_no],tap5_offset_global[lane_no][comp_no]);
#endif
        i = i*2;
        }
#if 0 // Done out now
      fSerdesSbCycleDelay(1000);
      fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x04,1,2,0);                //Allow SERDES to re-acquire Signal Detect
      fSerdesSbCycleDelay(1000);
#endif
      }
    }
   else
    {
    for(lane_no=0;lane_no<iLanes;lane_no++)
      {
#if 0 // Done out now
      fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x04,1,2,2);                //Force SERDES Signal Detect LO (Reset CDR, Att and Boost)
#endif
      for(comp_no=1;comp_no<5;comp_no++)
        {//Set comparator number
#if 1
        printf("Average comp offset for lane %d, comp %d = %d\n", lane_no,comp_no,cmp_offset_global[lane_no][comp_no]);
#endif
        OVR_CMP_TAP_OFFSETS(in_base,lane_no,comp_no,cmp_offset_global[lane_no][comp_no],0,0,0,0,0);
        }
#if 0 // Done out now
      fSerdesSbCycleDelay(1000);
      fUserRegFillField32(in_base + (lane_no * 0x200) + 0x200 + 0x04,1,2,0);                //Allow SERDES to re-acquire Signal Detect
      fSerdesSbCycleDelay(1000);
#endif
      }
    }
  }
#endif

#endif

/***********************************************************************/
#if 0
int Serdes_Example_PRBSTest(uint32_t in_base, int index, int diag_serdes_device_num)
{
    SERDES_DBG_BER_INIT_T ber_init_params;
    uint32_t lane_num;
    CSL_SERDES_RX_COEFF_T pRxCoeff;

    memset(&ber_init_params, 0, sizeof(ber_init_params));

    /* Test Initialization Parameters */
    ber_init_params.num_lanes = 4;
    ber_init_params.bertesttime = (uint64_t)100000000;
    ber_init_params.prbs_pattern = SERDES_PRBS_31;
    //ber_init_params.phy_type = serdes_phy_type;
    ber_init_params.phy_type = SERDES_HYPERLINK;
    ber_init_params.bist_tx_clk_en = SERDES_DBG_BIST_TX_CLK_ENABLED;
    ber_init_params.bist_rx_clk_en = SERDES_DBG_BIST_RX_CLK_ENABLED;
    ber_init_params.loopback_type = SERDES_DBG_NON_LOOPBACK;
    ber_init_params.lane_ctrl_rate = CSL_SERDES_LANE_HALF_RATE;

    ber_init_params.base_addr = in_base;

    /* Set up polarity */
    if (index == 0) {
        if (diag_serdes_device_num == 0)
        {
            ber_init_params.polarity[0] = 0;
            ber_init_params.polarity[1] = 0;
            ber_init_params.polarity[2] = 1;
            ber_init_params.polarity[3] = 1;
        }
        else if (diag_serdes_device_num == 1)
        {
            ber_init_params.polarity[0] = 0;
            ber_init_params.polarity[1] = 0;
            ber_init_params.polarity[2] = 0;
            ber_init_params.polarity[3] = 0;
        }
        else if (diag_serdes_device_num == 2)
        {
            ber_init_params.polarity[0] = 0;
            ber_init_params.polarity[1] = 0;
            ber_init_params.polarity[2] = 0;
            ber_init_params.polarity[3] = 0;
        }
        else if (diag_serdes_device_num == 3)
        {
            ber_init_params.polarity[0] = 1;
            ber_init_params.polarity[1] = 0;
            ber_init_params.polarity[2] = 0;
            ber_init_params.polarity[3] = 1;
        }
    }
    else {
      if (diag_serdes_device_num == 0)
        {
            ber_init_params.polarity[0] = 1;
            ber_init_params.polarity[1] = 0;
            ber_init_params.polarity[2] = 0;
            ber_init_params.polarity[3] = 1;
        }
        else if (diag_serdes_device_num == 1)
        {
            ber_init_params.polarity[0] = 0;
            ber_init_params.polarity[1] = 0;
            ber_init_params.polarity[2] = 1;
            ber_init_params.polarity[3] = 1;
        }
        else if (diag_serdes_device_num == 2)
        {
            ber_init_params.polarity[0] = 0;
            ber_init_params.polarity[1] = 0;
            ber_init_params.polarity[2] = 0;
            ber_init_params.polarity[3] = 0;
        }
        else if (diag_serdes_device_num == 3)
        {
            ber_init_params.polarity[0] = 0;
            ber_init_params.polarity[1] = 0;
            ber_init_params.polarity[2] = 0;
            ber_init_params.polarity[3] = 0;
        }
    }
    /* Enables the TX PRBS pattern */
    Serdes_Dbg_BERTest_TX(&ber_init_params);

    for(lane_num=0; lane_num<ber_init_params.num_lanes; lane_num++)
    {
        CSL_SerdesSetLanePolarity(ber_init_params.base_addr, lane_num, ber_init_params.polarity[lane_num]);
    }

    Serdes_Dbg_PRBS_Check(&ber_init_params);

    CSL_Serdes_Att_Boost_Calibration(ber_init_params.base_addr, ber_init_params.num_lanes, ber_init_params.lane_ctrl_rate, ber_init_params.phy_type, &pRxCoeff);

    for(lane_num=0; lane_num<ber_init_params.num_lanes; lane_num++)
    {
        printf("[PRBS] SOC#%d, Hyplnk port: %d, lane %d --- \tatt = %d\tboost = %d\n", diag_serdes_device_num, index, 
          lane_num, pRxCoeff.rx_att[lane_num], pRxCoeff.rx_boost[lane_num]);
    }

    return 0;
}
#endif
/** nothing past this line ***/
